#include<iostream>

using namespace std;

const int MAXN = 1e3 + 5;

int n, L, Q;
int l, r;
string a;

void update(int l, int r)
{
    for(int i = l;i<=r;i++)
    {
        if(a[i]=='+') a[i] = '-';
        else if(a[i]=='-') a[i] = '+';
    }
}

int simulate()
{
    int channel = 1, last = 1, last1;

    //cout << a << '\n';
    for(int i = 0;i<L;i++)
    {
        //cout << "   " << channel << " " << a[i] << '\n';

        if(a[i]=='+')
        {
            last = channel;

            channel++;
            if(channel==n+1) channel = 1;
        }
        else if(a[i]=='-')
        {
            last = channel;

            channel--;
            if(channel==0) channel = n;
        }
        else
        {
            last1 = channel;

            channel = last;
            last = last1;
        }
    }

    return channel;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> Q;

    cin >> a;
    L = a.size();

    for(int q = 0;q<Q;q++)
    {
        cin >> l >> r;

        update(l-1, r-1);
        cout << simulate() << '\n';
    }
}
/*
10 2
+--++
1 2
2 5

8 3
+o-+o+
3 5
1 6
1 3

5 2
++oo
3 4
2 3
*/
