///Quest Rogue <3
#include<iostream>
#include<vector>
using namespace std;
struct cell
{
    long value;
    long s,e;
};
cell k[524288];
void assign_borders(long t,long from,long to)
{
    k[t].s=from;
    k[t].e=to;
    if(from!=to)
    {
        assign_borders(2*t,from,(from+to)/2);
        assign_borders(2*t+1,((from+to)/2)+1,to);
    }
}
long full_sum(long t)
{
    if(k[t].s!=k[t].e)
    {
        k[t].value=full_sum(2*t)+full_sum(2*t+1);
    }
    return k[t].value;
}
void inv(long t)
{
    k[t].value=(0-k[t].value);
    if(k[t].s!=k[t].e)
    {
        inv(2*t);
        inv(2*t+1);
    }
}
void echo(long t,long val)
{
    if(t!=0)
    {
        k[t].value+=2*(val);
        echo(t/2,val);
    }
}
void change_diap(long t,long from, long to)
{
    //cout<<"change"<<t<<" "<<from<<" "<<to<<endl;
    if(from==k[t].s and to==k[t].e)
    {
        //cout<<"aaa";
        inv(t);
        //cout<<"after"<<k[12].value<<endl;
        echo(t/2,k[t].value);
        //cout<<"after"<<k[12].value<<endl;
        return;
    }
    if(k[t].s<=from and to<=((k[t].s+k[t].e)/2))
    {
        change_diap(2*t,from,to);
    }
    else if(((k[t].s+k[t].e)/2)<from and to<=k[t].e)
    {
        change_diap((2*t)+1,from, to);
    }
    else
    {
        change_diap(2*t,from,k[2*t].e);
        change_diap((2*t)+1,k[2*t+1].s, to);
    }
}
void init(vector<long>seq,long n)
{
    long ss=1;
    while(ss<n)
    {
        ss=2*ss;
    }
    for(long i=n; i<ss; i++)
    {
        seq.push_back(0);
    }
    n=ss;
    for(long i=0; i<n; i++)
    {
        k[i+n].value=seq[i];
    }
    assign_borders(1,0,n-1);
    full_sum(1);
}
int main()
{
    cin.tie();
    ios::sync_with_stdio();
    long n,q;
    string s;
    vector<long> seq;
    cin>>n>>q;
    cin>>s;
    for(long i=0; i<=s.size(); i++)
    {
        if(i==s.size())
        {
            if(seq[i-1]==0)
            {
                for(long j=i-1; j>=0; j--)
                {
                    if(seq[j]!=0)
                    {
                        if(((i-j)%2)==0)
                        {
                            seq[j]=0;
                        }
                        break;
                    }
                }
            }
            break;
        }
        if(s[i]=='+')
        {
            seq.push_back(1);
        }
        else if(s[i]=='-')
        {
            seq.push_back(-1);
        }
        else
        {
            seq.push_back(0);
        }
        if(i>=1)
        {
            if(seq[i]!=0 and seq[i-1]==0)
            {
                for(long j=i-1; j>=0; j--)
                {
                    if(seq[j]!=0)
                    {
                        if(((i-j)%2)==0)
                        {
                            seq[j]=0;
                        }
                        break;
                    }
                }
            }
        }
    }

    init(seq,seq.size());

    long a,b;
    for(long j=0; j<q; j++)
    {
        cin>>a>>b;
        a--;
        b--;
        change_diap(1,a,b);
        /*for(long i=0;i<16;i++)
        {
        cout<<k[i].s<<" "<<k[i].e<<" "<<k[i].value<<endl;
        }*/
        cout<<(k[1].value+n)%n+1<<endl;
    }


}


