#include <iostream>
#include <string>

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n, q;
    std::cin >> n >> q;
    if(n <= 1e3 && q <= 1e3) {
            return 1234;
        std::string s;
        std::cin >> s;
        for(int i = 0; i < q; i++) {
            int rb, re;
            std::cin >> rb >> re;
            --rb;
            --re;
            int curr = 1, prev = 1, prevp = -1;
            for(int i = 0; i < s.size(); i++) {
                if(rb <= i && re >= i) {
                    if(s[i] == '+')
                        s[i] = '-';
                    else if(s[i] == '-')
                        s[i] = '+';
                }
                if(s[i] == '+')
                    curr ++;
                else if(s[i] == '-')
                    curr --;
                else
                    curr = prevp;
                if(curr == 0)
                    curr = n;
                else if(curr == n+1)
                    curr = 1;
                prevp = prev;
                prev = curr;
            }
            std::cout  << curr << '\n';
        }
    } else {
        std::string s;
        std::cin >> s;
        int ans = 1, prev = 1, prevp = -1;
        for(auto &x:s) {
            if(x == '+')
                ans ++;
            else if(x == '-')
                ans --;
            else
                ans = prevp;
            if(ans == 0)
                ans = n;
            else if(ans == n+1)
                ans = 1;
            prevp = prev;
            prev = ans;
        }
        for(int i = 0; i < q; i++) {
            int rb, re;
            std::cin >> rb >> re;
            --rb;
            --re;
            int delta = 0;
            for(int j = rb; j <= re; j++) {
                if(s[j] == '+') {
                    s[j] = '-';
                    delta -= 2;
                } else if(s[j] == '-') {
                    s[j] = '+';
                    delta += 2;
                }
            }
            ans += delta;
            while(ans < 0)
                ans += n;
            while(ans > n)
                ans -= n;
            std::cout << ans << "\n";
        }
    }
    return 0;
}
