#include <iostream>

int n, q;
std::string s;
void change(int a, int b) {
	for(int i = a;i <= b;i ++) {
		if(s[i] == '+') s[i] = '-';
		else if(s[i] == '-') s[i] = '+';
	}
}

int eval() {
	int curr = 1;
	int prev = 1;

	for(auto c : s) {
		if(c == '+') {
			prev = curr;
			curr += 1;
			if(curr > n) curr = 1;
		}
		if(c == '-') {
			prev = curr;
			curr -= 1;
			if(curr < 1) curr = n;
		}
		if(curr == 'o') {
			std::swap(prev, curr);
		}
	}

	return curr;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> q >> s;

	for(int i = 0;i < q;i ++) {
		int a, b;
		std::cin >> a >> b;
		a --;
		b --;
		change(a, b);
		std::cout << eval() << '\n';
	}

	return 0;
}
