#include <iostream>
#include <algorithm>

int n, q;
std::string s;
const int MAX_L = 5*100000;

void change(int a, int b) {
	for(int i = a;i <= b;i ++) {
		if(s[i] == '+') s[i] = '-';
		else if(s[i] == '-') s[i] = '+';
	}
}

int eval() {
	int curr = 1;
	int prev = 1;

	for(auto c : s) {
		if(c == '+') {
			prev = curr;
			curr += 1;
			if(curr > n) curr = 1;
		}
		if(c == '-') {
			prev = curr;
			curr -= 1;
			if(curr < 1) curr = n;
		}
		if(c == 'o') {
			std::swap(prev, curr);
		}
	}

	return curr;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> q >> s;
	std::string s2;

	int streak = 0;
	int prev = 0;
	for(int i = s.size()-1;i >= 0;i --) {
		if(s[i] == 'o') {
			streak ++;
		} else {
			if(streak == 0) {
				s2.push_back(s[i]);
				continue;
			}
			if(streak % 2 == 0) {
				s2.push_back(s[i]);
			}
			streak = 0;
		}
	}

	std::reverse(s2.begin(), s2.end());
	s = s2;

	for(int i = 0;i < q;i ++) {
		int a, b;
		std::cin >> a >> b;
		a --;
		b --;
		change(a, b);
		std::cout << eval() << '\n';
	}

	return 0;
}
