#include <iostream>
#include <string>

using namespace std;

int n, q;
string seq;

int main ()
{
    cin.tie (NULL);
    ios::sync_with_stdio(false);

    cin >> n >> q;
    cin >> seq;

    if (seq.size() <= 1000)
    {
        for (int j = 0; j < q; ++j)
        {
            int a, b;
            cin >> a >> b;
            --a;
            --b;

            int res = 1, l1 = 1, l2 = 1;
            for (int i = 0; i < seq.size(); ++i)
            {
                if (a <= i && i <= b)
                {
                    if (seq[i] == '+')
                    {
                        seq[i] = '-';
                    }
                    else if (seq[i] == '-')
                    {
                        seq[i] = '+';
                    }
                }

                if (seq[i] == '+')
                {
                    ++res;
                }
                else if (seq[i] == '-')
                {
                    --res;
                }
                else
                {
                    res = l1;
                }
                l1 = l2;
                l2 = res;

                if (res == n + 1)
                {
                    res = 1;
                }
                else if (res == 0)
                {
                    res = n;
                }

                //cout << i << ' ' << l1 << ' ' << l2 << "   " << res << '\n';
            }
            //cout << seq << '\n';

            cout << res << '\n';
        }

        return 0;
    }

    int br = 0;
    int res[10005];
    for (int i = 0; i < seq.size(); i += 105)
    {
        int curr = 0, l1 = 0, l2 = 0;
        for (int j = 0; j < 105 && i + j < seq.size(); ++j)
        {
            if (seq[i + j] == '+')
            {
                curr += 1;
            }
            else if (seq[i + j] == '-')
            {
                curr -= 1;
            }
            else
            {
                curr = l1;
            }
            l1 = l2;
            l2 = curr;
        }

        res[br] = curr;
        ++br;
    }

    /*for (int i = 0; i < br; ++i)
    {
        cout << res[i] << '\n';
    }*/

    for (int z = 0; z < q; ++z)
    {
        int a, b;
        cin >> a >> b;

        int f = a / 105, s = b / 105;
        /*if (a % 105 == 0)
        {
            --f;
        }
        if (b % 105 == 0)
        {
            --s;
        }*/

        --a; --b;
        //cout << f << ' ' << s << '\n';
        //cout << "predi " << res[0] << '\n';
        for (int i = f; i <= s; ++i)
        {
            int curr = 0, l1 = 0, l2 = 0;
            for (int j = 0, idx = i * 105 + j; j < 105 && idx < seq.size(); ++j, ++idx)
            {
                if (a <= idx && idx <= b)
                {
                    if (seq[idx] == '+')
                    {
                        seq[idx] = '-';
                    }
                    else if (seq[idx] == '-')
                    {
                        seq[idx] = '+';
                    }
                }

                if (seq[idx] == '+')
                {
                    curr += 1;
                }
                else if (seq[idx] == '-')
                {
                    curr -= 1;
                }
                else
                {
                    curr = l1;
                }
                l1 = l2;
                l2 = curr;
                //cout << "curr " << seq[idx] << ' ' << curr << '\n';
            }

            res[i] = curr;
        }
        //cout << "sled " << res[0] << '\n';

        int sol = 1;
        for (int i = 0; i < br; ++i)
        {
            sol += res[i];
        }

        if (sol < 1)
        {
            //cout << 'a';
            sol = (0 - sol) % n;
            sol = n - sol;
        }
        else if (sol > n)
        {
            //cout << 'b';
            sol %= n;
        }

        //cout << seq << '\n';
        cout << sol << '\n';
    }
    return 0;
}
