#include <iostream>

using namespace std;

int n, k;
bool arr[2005];
bool saved[2005];

pair <int, int> solve (int idx)
{
    pair <int, int> res;
    res.first = 1;
    res.second = 0;

    int next = idx + 1;
    while (next < 2 * n && !arr[next])
    {
        ++next;
    }

    if (next < 2 * n)
    {
        res = solve (next);
    }

    int br = 0;
    for (int i = idx - 1; !saved[idx] && i > 0; --i)
    {
        if (!arr[i] && !saved[i])
        {
            ++br;
        }
    }

    res.first = res.first * br % 1001027;
    res.second += 1;

    return res;
}

int main ()
{
    cin.tie (NULL);
    ios::sync_with_stdio(false);

    cin >> n >> k;
    for (int i = 0; i < k; ++i)
    {
        int idx;
        cin >> idx;
        arr[idx - 1] = true;
        saved[idx - 1] = true;
    }

    int s = 0, f = -1;
    for (int i = 0; i < 2 * n; ++i)
    {
        if (arr[i])
        {
            ++s;
            if (f == -1)
            {
                f = i;
            }
        }
        else
        {
            if (s > 0)
            {
                --s;
            }
            else
            {
                arr[i] = true;
                ++s;
                if (f == -1)
                {
                    f = i;
                }
            }
        }
        //cout << arr[i] << ' ';
    }
    //cout << '\n';

    pair <int, int> res = solve(f);

    cout << res.first + res.second << '\n';

    return 0;
}
