#include <iostream>
#include <string>

using namespace std;

int n, q;
string seq;

int p[500005];

int main ()
{
    cin.tie (NULL);
    ios::sync_with_stdio(false);

    cin >> n >> q;
    cin >> seq;

    if (seq.size() <= 1000)
    {
        for (int j = 0; j < q; ++j)
        {
            int a, b;
            cin >> a >> b;
            --a;
            --b;

            int res = 1, l1 = 1, l2 = 1;
            for (int i = 0; i < seq.size(); ++i)
            {
                if (a <= i && i <= b)
                {
                    if (seq[i] == '+')
                    {
                        seq[i] = '-';
                    }
                    else if (seq[i] == '-')
                    {
                        seq[i] = '+';
                    }
                }

                if (seq[i] == '+')
                {
                    ++res;
                }
                else if (seq[i] == '-')
                {
                    --res;
                }
                else
                {
                    res = l1;
                }
                l1 = l2;
                l2 = res;

                if (res == n + 1)
                {
                    res = 1;
                }
                else if (res == 0)
                {
                    res = n;
                }

                //cout << i << ' ' << l1 << ' ' << l2 << "   " << res << '\n';
            }
            //cout << seq << '\n';

            cout << res << '\n';
        }

        return 0;
    }

    int br = 0;
    int res[10005];
    for (int i = 0; i < seq.size(); i += 12)
    {
        for (int j = 0, idx = i + j; j < 12 && idx < seq.size(); ++j)
        {
            if (idx - 1 >= 0)
            {
                p[idx] = p[idx - 1];
            }

            if (seq[idx] == '+')
            {
                p[idx] += 1;
            }
            else if (seq[idx] == '-')
            {
                p[idx] -= 1;
            }
            else
            {
                if (idx - 2 >= 0)
                {
                    p[idx] = p[idx - 2];
                }
                else
                {
                    p[idx] = 1;
                }
            }
        }

        res[br] = p[i + 9];
        ++br;
    }

    /*for (int i = 0; i < br; ++i)
    {
        cout << res[i] << '\n';
    }*/

    for (int z = 0; z < q; ++z)
    {
        int a, b;
        cin >> a >> b;

        int x = a / 12;
        for (int j = 0, idx = x * 12 + j; j < 12 && idx < seq.size(); ++j, ++idx)
        {
            if (a <= idx && idx <= b)
            {
                if (seq[idx] == '+')
                {
                    seq[idx] = '-';
                }
                else if (seq[idx] == '-')
                {
                    seq[idx] = '+';
                }
            }

            if (idx - 1 >= 0)
            {
                p[idx] = p[idx - 1];
            }

            if (seq[idx] == '+')
            {
                p[idx] += 1;
            }
            else if (seq[idx] == '-')
            {
                p[idx] -= 1;
            }
            else
            {
                if (idx - 2 >= 0)
                {
                    p[idx] = p[idx - 2];
                }
                else
                {
                    p[idx] = 1;
                }
            }
        }

        res[x] = p[x * 12 + 9];
        //cout << "sled " << res[0] << '\n';

        int sol = 1;
        for (int i = 0; i < br; ++i)
        {
            sol += res[i];
        }

        if (sol < 1)
        {
            //cout << 'a';
            sol = (0 - sol) % n;
            sol = n - sol;
        }
        else if (sol > n)
        {
            //cout << 'b';
            sol %= n;
        }

        //cout << seq << '\n';
        cout << sol << '\n';
    }
    return 0;
}
