#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool set [1024];
int open_to [1024];
long long answer = 0;
int n, k;

long long mem [1024][1024];

long long ans (int open, int close)
{
	if (mem [open][close] != 0)
		return mem [open][close];
	if (open < 0 or close < 0)
		return 0;
	if (open == 0 and close == 0)
		return mem [open][close] = 1;
	if (close < open)
		return mem [open][close] = 0;
	if (set [n - open + n - close])
		return mem [open][close] = ans (open - 1, close);
	
	return mem [open][close] = 
	       (ans (open - 1, close)
	      + ans (open, close - 1)) % 1001027;
}

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);	
	cin >> n >> k;
	for (int i = 0 ; i < k ; i ++)
	{
		int a;
		cin >> a; a --;
		set [a] = true;
	}
	/*cout << ans (n, n) << endl;
	for (int opened = 0 ; opened <= n ; opened ++, cout << endl)
		for (int closed = 0 ; closed <= n ; closed ++)
			cout << mem [opened][closed] << " ";
	cout << endl;*/
	for (int opened = 0 ; opened <= n ; opened ++)
	{
		for (int closed = opened ; closed <= n ; closed ++)
		{
			if (opened == 0 and closed == 0)
				mem [opened][closed] = 1;
			else if (opened == 0 and not set [n - opened + n - closed])
				mem [opened][closed] = mem [opened][closed - 1];
			else if (opened == 0 and set [n - opened + n - closed])
				mem [opened][closed] = 0;
			else if (set [n - opened + n - closed])
				mem [opened][closed] = mem [opened - 1][closed];
			else
				mem [opened][closed] = (mem [opened - 1][closed] + mem [opened][closed - 1]) % 1001027;
		}
	}
	/*
	for (int opened = 0 ; opened <= n ; opened ++, cout << endl)
		for (int closed = 0 ; closed <= n ; closed ++)
			cout << mem [opened][closed] << " ";*/
	cout << mem [n][n] << endl;
}
