#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n, k;
string commands;
int change [500000];

int mabs (int a)
{
	return (a + n) % n;
}

int mround (int a)
{
	if (a <= -n)
		return a + n;
	if (a >= n)
		return a - n;
	return a;
}

void rotate (int s, int e)
{
	/*
	for (int i = s ; i <= e ; i ++)
		if (commands [i] == '+')
			commands [i] = '-';
		else if (commands [i] == '-')
			commands [i] = '+';
	*/
	int start_change = ((s == 0) ? 0 : change [s - 1]);
	int big_change = change [e + 1] - change [e];
	for (int i = s ; i <= e ; i ++)
		change [i] = mabs (mround (-(change [i] - 2 * start_change)));
	big_change = change [e] + big_change - change [e + 1];
	for (size_t i = e + 1 ; i < commands.size () ; i ++)
		change [i] = mabs (mround (change [i]) + big_change);
}

int calc ()
{
	/*
	int prev_channel = -1;
	int channel = 0;
	for (auto& x : commands)
	{
		if (x == 'o')
		{
			swap (prev_channel, channel);
		}
		else if (x == '+')
		{
			prev_channel = channel;
			channel = (channel + 1 + n) % n;
		}
		else if (x == '-')
		{
			prev_channel = channel;
			channel = (channel - 1 + n) % n;
		}
		//cout << prev_channel << " " << channel << endl;
	}*/
	return mabs (1 + change [commands.size () - 1]);
}

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);	
	cin >> n >> k;
	cin >> commands;
	for (size_t i = 0 ; i < commands.size () ; i ++)
	{
		if (commands [i] == '+')
		{
			if (i == 0)
				change [i] = 1;
			else
				change [i] =  (mround (change [i - 1] + 1));
		}
		else if (commands [i] == '-')
		{
			if (i == 0)
				change [i] = -1;
			else
				change [i] =  (mround (change [i - 1] - 1));
		}
		else if (commands [i] == 'o')
		{
			if (i == 2)
				change [i] = 0;
			else
				change [i] = change [i - 2];
		}
	}
	/*
	for (size_t i = 0 ; i < commands.size () ; i ++)
		cout << change [i] << " ";
	cout << endl;
	*/
	for (int i = 0 ; i < k ; i ++)
	{
		int a, b;
		cin >> a >> b; a --; b --;
		rotate (a, b);
		
		/*
		for (size_t i = 0 ; i < commands.size () ; i ++)
			cout << change [i] << " ";
		cout << endl;
		*/
		cout << calc () << endl;
	}
}
