#include<bits/stdc++.h>
const int INF=1e9+17;
const int MAXN=1017;
using namespace std;

//#pragma GCC optimize("O3")
//#pragma GCC target("sse4")

int n, rt[MAXN], sz[MAXN];
long long ans;
vector<pair<int, pair<int, int> > > edges;
vector<vector<int> > f;

void init() {for(int i=0; i<MAXN; i++) rt[i]=i, sz[i]=1;}
int root(int i) {return rt[i]==i?i:rt[i]=root(rt[i]);}
bool con(int a, int b) {return root(a)==root(b);}
void unite(pair<int, pair<int, int> > temp)
{
    int a=temp.second.first, b=temp.second.second, w=temp.first;
    if(con(a, b)) return;
    if(sz[root(a)]>sz[root(b)]) swap(a, b); //size of a < size of b
    sz[root(b)]+=sz[root(a)];
    rt[root(a)]=root(b);
    ans+=w;
}

void mainp()
{
    int n, k;
    cin>>n>>k;
    f.resize(n);
    for(int i=0; i<n; i++)
    {
        int num;
        cin>>num;
        f[i].resize(num);
        for(int j=0; j<num; j++) cin>>f[i][j];
        sort(f[i].begin(), f[i].end());
    }

    for(int i=0; i<n; i++)
        for(int j=i+1; j<n; j++)
        {
            int p1=0, p2=0, num=-1;
            while(p1<f[i].size()&&p2<f[j].size())
            {
                if(f[i][p1]==f[j][p2]) {num=f[i][p1]; break;}
                while(p1<f[i].size()&&p2<f[j].size()&&f[i][p1]<f[j][p2]) p1++;
                while(p1<f[i].size()&&p2<f[j].size()&&f[j][p2]<f[i][p1]) p2++;
            }

            //cout<<i<<" "<<j<<" "<<num<<endl;
            if(num!=-1) edges.push_back({num, {i, j}});
            else edges.push_back({k+1, {i, j}});
        }

    sort(edges.begin(), edges.end());
    init();
    for(int i=0; i<edges.size(); i++) unite(edges[i]);
    cout<<ans<<endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    mainp();
    return 0;
}

/*
3 6
3 1 2 3
3 3 4 5
3 4 5 6
*/

