#include<iostream>
#include<cstdio>
using namespace std;

long long mod=1001027,dp[1020];
int n,k;

void dp_fill()
{
	dp[1]=1;
	dp[2]=2;
	dp[3]=5;
	for(int i=4;i<=5;i++)
	{
		dp[i]=dp[i-1]%mod;
		for(int j=i-1;j>=1;j--)
		{
			if(j==i-j) 
			{
				dp[i]=(dp[i]+dp[j]*dp[j])%mod;
			}
			else dp[i]=(dp[i]+(dp[j]*dp[i-j])-1)%mod;
		}
		if(i%2==0) dp[i]=(dp[i]+(i/2-1))%mod;
		else dp[i]=(dp[i]+(i/2))%mod;
	}
}

void brackets_do()
{
	dp[0]=1;
	long long ans=0;
	for(int i=2*n;i>=n;i=i-2)
	{
			int size1=(i-2*k);
			int size=(2*n-i)/2;
		ans=(ans+dp[size]*dp[size1])%mod;	
	}
	printf("%lld\n",ans);
}

void init()
{
	scanf("%d%d",&n,&k);
	dp_fill();
	brackets_do();
}

int main()
{
	init();
}
