#include<iostream>
#include<vector>

using namespace std;

const int MAXN=1000;
const int MAXK=32;
int n, k;
struct ofis
{
    int r;
    int k[MAXK+5];
};
ofis s[MAXN+10];
vector<int> con[MAXK+10];
int par[MAXN+10];
int vr=1;
int minc=0;

void input()
{
    cin>>n>>k;
    for (int i=0; i<n; i++)
    {
        cin>>s[i].r;
        for (int j=0; j<s[i].r; j++)
        {
            cin>>s[i].k[j];
            con[s[i].k[j]].push_back(i);
        }
    }
}

void output()
{
    cout<<minc<<endl;
}

int find_parent(int curr)
{
    if (par[curr]==curr) return curr;
    else
    {
        par[curr]=find_parent(par[curr]);
        return par[curr];
    }
}

bool unite(int a, int b)
{
    if (a!=b)
    {
        int p1, p2;
        p1=find_parent(a);
        p2=find_parent(b);
        if (p1!=p2)
        {
            par[p1]=p2;
            return 1;
        }
    }
    return 0;
}

void setpar()
{
    for (int i=0; i<n; i++)
    {
        par[i]=i;
    }
}

void solve()
{
    setpar();
    for (int i=1; i<=k; i++)
    {
        for (int j=1; j<con[i].size(); j++)
        {
            if (unite(con[i][j], con[i][j-1]))
            {
                vr++;
                minc+=i;
            }
        }
        if (vr==n) break;
    }
    /*for (int i=0; i<n; i++)
    {
        cerr<<par[i]<<endl;
    }*/
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
3 6
3 1 2 3
3 3 4 5
3 4 5 6
*/
