#include<iostream>

using namespace std;

const int MAXN=1000;
const int MOD=1001027;
int n, k;
bool m[MAXN*2+10];
int dp[MAXN*2+10];
int w=0;

void input()
{
    int temp;
    cin>>n>>k;
    for (int i=0; i<k; i++)
    {
        cin>>temp;
        m[temp-1]=1;
    }
    if(!m[0])
    {
        k++;
        m[0]=1;
    }
}

void output()
{
    cout<<w<<endl;
}

int slowrek(int p, int o, int z)
{
    if (p==n*2) return 1;
    else
    {
        int sb=0;
        if (m[p]) sb=(sb+slowrek(p+1, o, z))%MOD;
        else
        {
            if (o<n) sb=(sb+slowrek(p+1, o+1, z))%MOD;
            if (z<n && o>z) sb=(sb+slowrek(p+1, o, z+1))%MOD;
        }
        return sb;
    }
}

int fast()
{
    int b=0, sr=1;
    int sm, sm2;
    dp[0]=1;
    for (int i=1; i<n*2-2; i++)
    {
        if (m[i])
        {
            dp[i]=dp[i-1];
            sr++;
        }
        else
        {
            dp[i]=dp[i-1]*2;
            if (i%2==0)
            {
                sm=i/2-sr;
                if (sm>=0 && sm<=b)
                {
                    sm2=1;
                    for (int j=b; j>b-sm; j--)
                        sm2*=j;
                    for (int j=1; j<=sm; j++)
                        sm2/=j;
                    //cerr<<sm2<<'z';
                    dp[i]-=sm2;
                }
            }
            if (i>=n)
            {
                sm=n-k;
                if (sm>=0 && sm<=b)
                {
                    sm2=1;
                    for (int j=b; j>b-sm; j--)
                        sm2*=j;
                    for (int j=1; j<=sm; j++)
                        sm2/=j;
                    //cerr<<sm2<<'o';
                    dp[i]-=sm2;
                }
            }
            b++;
        }
        dp[i]%=MOD;//cerr<<dp[i]<<endl;
    }
    if (n>1) dp[n*2-2]=dp[n*2-3];
    dp[n*2-1]=dp[n*2-2];
}

void solve()
{
    if (k>n || m[n*2-1]) w=0;
    //w=slowrek(1, k, 0);
    else
    {
        fast();
        w=dp[n*2-1];
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

