#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdint>
using namespace std;

#define endl '\n'

#define FLAG_DUMB       (1U<<0U)
#define FLAG_AI_BI      (1U<<1U)
#define FLAG_NO_RETURN  (1U<<2U)
#define FLAG_FUCK       (1U<<3U)

struct __input
{
    uint32_t n;
    vector < char > sm;
    vector < pair < uint32_t, uint32_t > > query;
    uint32_t flags;

} input;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
}

void get_input()
{
    input.flags=FLAG_AI_BI | FLAG_NO_RETURN;
    uint32_t q;
    cin>>input.n>>q;
    input.query.resize(q);
    while(cin.get()!='\n');
    char x;
    while((x=cin.get())!='\n'&&x!='\r')
    {
        input.sm.push_back(x);
        if(x=='o')input.flags &= (~(FLAG_NO_RETURN));
    }
    //while(cin.get()!='\n');
    for(uint32_t i=0; i<input.query.size(); i++)
    {
        cin>>input.query[i].first>>input.query[i].second;
        input.query[i].first--;input.query[i].second--;
        if(input.query[i].first!=input.query[i].second)
            input.flags &= (~(FLAG_AI_BI));
    }
    if((uint64_t)input.sm.size()*(uint64_t)input.query.size()<=(uint64_t)1000000)
        input.flags=FLAG_DUMB;
    else if(input.flags==0)
        input.flags=FLAG_FUCK;
    else if((input.flags & FLAG_AI_BI)&&(input.flags & FLAG_NO_RETURN))
        input.flags=FLAG_NO_RETURN;
}

void solve_dumb()
{
    for(uint32_t i=0; i<input.query.size(); i++)
    {
        uint32_t cur=1, pr_c=1;
        for(uint32_t j=0; j<input.sm.size(); j++)
        {
            if(input.query[i].first<=j&&j<=input.query[i].second)
            {
                //cout<<"A: "<<input.sm[j]<<endl;
                if(input.sm[j]=='+')
                    input.sm[j]='-';
                else if(input.sm[j]=='-')
                    input.sm[j]='+';
                //cout<<"B: "<<input.sm[j]<<endl<<endl;
            }

            if(input.sm[j]=='+')
            {
                pr_c=cur;
                if(cur==input.n)cur=1;
                else cur++;
                //cout<<"A";
            }
            else if(input.sm[j]=='-')
            {
                pr_c=cur;
                if(cur==1)cur=input.n;
                else cur--;
                //cout<<"R";
            }
            else
            {
                swap(pr_c, cur);
            }

        }
        cout<<cur<<endl;
    }
}
int main()
{
    init();
    get_input();
    //cout<<input.n<<' '<<input.sm.size()<<' '<<input.query.size()<<' '<<input.flags<<endl;
    if(input.flags&FLAG_DUMB)
        solve_dumb();

    return 0;
}
