#include <iostream>
using namespace std;

const int MAXN = 2 * 1024;
const int MOD = 1001027;

int n, k;
int open[MAXN];
int cnt = 0;

void Rec(int i = 1, int j = 0)
{
    if (i == 2 * n + 1)
    {
        if (j == 0) cnt = (cnt + 1) % MOD;
        return;
    }

    if (j > n) return;

    Rec(i + 1, j + 1);
    if (open[i] == 0 and j != 0) Rec(i + 1, j - 1);
}

int main()
{
    cin >> n >> k;
    for (int i = 1; i <= k; ++ i)
    {
        int x;
        cin >> x;
        open[x] = 1;
    }

    Rec();

    cout << cnt << endl;
    return 0;
}

