#include <iostream>
#include <algorithm>
#include <string>
using namespace std;
const int maxM=500010;
string s;
int n,q,m,arr[maxM],sum,cnt_zero[maxM],queries[maxM][2],segtree[4*maxM],lazy[4*maxM];
long long ans;
void solve1(int a,int b)
{
    for(int i=a; i<=b; i++)
        arr[i]=-arr[i];
    int sum=0;
    int last=-1;
    for(int i=0; i<m; i++)
    {
        if(arr[i])
        {
            sum+=arr[i];
            last=i;
        }
        else
        {
            if((i-last)%2==0)
                sum+=arr[last];
            else
                sum+=-arr[last];
        }
    }
    int t=(1+n+sum)%n;
    if(t==0)
        t=n;
    cout<<t<<endl;
}
void findSum()
{
    int last=-1;
    int first=-1;
    for(int i=0; i<m; i++)
    {
        if(arr[i])
        {
            sum+=arr[i];
            last=i;
            first=-1;
        }
        else
        {
            if(first==-1)
                first=i;
            cnt_zero[first]++;
            if((i-last)%2==0)
                sum+=arr[last];
            else
                sum+=-arr[last];
        }
    }
}
void solve2(int a,int b)
{
    arr[a]=-arr[a];
    sum+=arr[a]*2;
    if(cnt_zero[a+1] && cnt_zero[a+1]%2==1)
        sum+=-arr[a]*2;
    int t=(1+sum+n)%n;
    if(t==0)
        t=n;
    cout<<t<<endl;
}
void build(int nd,int le,int ri)
{
    if(le==ri){
        segtree[nd]=arr[le];
        return;
    }
    int mid=(le+ri)>>1;
    build(2*nd,le,mid);
    build(2*nd+1,mid+1,ri);
    segtree[nd]=segtree[2*nd]+segtree[2*nd+1];
}
void updateLazy(int nd,int le,int ri)
{
    if(lazy[nd]==0)return;
    if(le!=ri){
        lazy[2*nd]=-lazy[2*nd];
        lazy[2*nd+1]=-lazy[2*nd+1];
        segtree[2*nd]=-segtree[2*nd];
        segtree[2*nd+1]=-segtree[2*nd+1];
    }
    lazy[nd]=0;
}
void update(int nd,int le,int ri,int p,int q)
{
    if(le>q || ri<p)return;
    if(le>=p && ri<=q){
        segtree[nd]=-segtree[nd];
        lazy[nd]=-1;
        updateLazy(nd,le,ri);
        ///cout<<le<<" "<<ri<<" "<<segtree[nd]<<endl;
        return;
    }
    int mid=(le+ri)>>1;
    update(2*nd,le,mid,p,q);
    update(2*nd+1,mid+1,ri,p,q);
    segtree[nd]=segtree[2*nd]+segtree[2*nd+1];
    ///cout<<le<<" "<<ri<<" "<<segtree[nd]<<endl;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int i,j,a,b;
    bool st=1;
    cin>>n>>q;
    cin>>s;
    m=s.size();
    for(i=0; i<m; i++)
    {
        if(s[i]=='+')
            arr[i]=1;
        else if(s[i]=='-')
            arr[i]=-1;
    }
    if(m<=1000 && q<=1000)
    {
        for(i=0; i<q; i++)
        {
            cin>>a>>b;
            solve1(a-1,b-1);
        }
    }
    else
    {
        findSum();
        for(i=0; i<q; i++)
        {
            cin>>queries[i][0]>>queries[i][1];
            ///solve2(a-1,b-1);
            if(queries[i][0]!=queries[i][1])
                st=0;
        }
        if(st==1)
        {
            for(i=0; i<q; i++)
            {
                solve2(queries[i][0],queries[i][1]);
            }
        }
        else
        {
            build(1,0,m-1);
            for(i=0; i<q; i++)
            {
                cin>>a>>b;
                update(1,0,m-1,a-1,b-1);
                int t=(1+segtree[1]+n)%n;
                if(t==0)
                    t=n;
                cout<<t<<endl;
            }
        }
    }
}
