#include<bits/stdc++.h>
using namespace std;
string s;
int seg_tree[2000012], actual[500002], i, j, n, q, a, b;
bool lazy[2000012];
void build(int ind, int l, int r)
{
    if(l==r)
    {
        seg_tree[ind]=actual[l];
        //cout<<ind<<" "<<seg_tree[ind]<<"\n";
        return;
    }
    int mid = (l+r)/2;
    build(2*ind, l, mid);
    build(2*ind+1, mid+1, r);
    seg_tree[ind]=seg_tree[2*ind]+seg_tree[2*ind+1];
    //cout<<ind<<" "<<seg_tree[ind]<<"\n";
}
void lazy_prop(int ind)
{
    if(!lazy[ind])
        return;
    lazy[2*ind]=!lazy[2*ind];
    seg_tree[2*ind]= -seg_tree[2*ind];
    lazy[2*ind+1]=!lazy[2*ind+1];
    seg_tree[2*ind+1]= -seg_tree[2*ind+1];
    lazy[ind]=false;
}
void update(int ind, int l, int r, int upl, int upr)
{
    if(r<upl || l>upr)
    {
        //cout<<"out "<<ind<<"\n";
        return;
    }
    if(l==r)
    {
        seg_tree[ind]=-seg_tree[ind];
        //cout<<"bot "<<ind<<" "<<seg_tree[ind]<<"\n";
        return;
    }
    if(l>=upl && r<=upr)
    {
        lazy[ind]=true;
        seg_tree[ind]=-seg_tree[ind];
        //cout<<"lazy "<<ind<<" "<<seg_tree[ind]<<"\n";
        return;
    }
    lazy_prop(ind);
    int mid = (l+r)/2;
    update (2*ind, l, mid, upl, upr);
    update (2*ind+1, mid+1, r, upl, upr);
    seg_tree[ind]=seg_tree[2*ind]+seg_tree[2*ind+1];
    //cout<<"part "<<ind<<" "<<seg_tree[ind]<<"\n";
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>q>>s;
    for(i=0; i<s.size(); i++)
    {
        if(s[i]=='+')
            actual[i]=1;
        else if(s[i]=='-')
            actual[i]=-1;
        else
            actual[i]=0;
        if(i==0)
            continue;
        if(actual[i]!=0 && actual[i-1]==0)
        {
            int br=0;
            for (j=i-1; j>=0; j--)
            {
                if(actual[j]==0)
                    br++;
                else
                    break;
            }
            if(br%2!=0)
                actual[j]=0;
        }
    }
    if(actual[s.size()-1]==0)
        {
            int br=0;
            for (j=i-1; j>=0; j--)
            {
                if(actual[j]==0)
                    br++;
                else
                    break;
            }
            if(br%2!=0)
                actual[j]=0;
        }
    //for(i=0;i<s.size();i++)cout<<actual[i]<<" ";
    build(1,0, s.size()-1);
    for(i=0; i<q; i++)
    {
        cin>>a>>b;
        update(1, 0, s.size()-1, a-1, b-1);
        int ans=seg_tree[1]%n;
        if(ans<0)
            ans+=n;
        cout<<ans+1<<"\n";
    }
    return 0;
}
/**
10 2
+--++
1 2
2 5
*/
/**
8 3
+o-+o+
3 5
1 6
1 3
*/
/**
5 2
++oo
3 4
2 3
*/
