#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1001;

int n, k;

struct node
{
    int index, c, f;
    node(int _index, int _c, int _f)
    {
        index = _index;
        c = _c;
        f = _f;
    }
    bool operator<(node other) const
    {
        if(c > other.c) return true;
        if(c < other.c) return false;
        if(f < other.f) return true;
        if(f > other.f) return false;
        return true;
    }
};

vector <int> a[MAXN];
bool v[MAXN];

int getCena(int f, int s)
{
    int s1 = a[f].size(), s2 = a[s].size();
    int l = 0, r = 0;
    while(l < s1 && r < s2)
    {
        if(a[f][l] == a[s][r])
        {
            return a[f][l];
        }
        else if(a[f][l] < a[s][r])
        {
            l++;
        }
        else
        {
            r++;
        }
    }
    return k + 1;
}

int Solve()
{
    priority_queue <node> pq;
    pq.push(node(0, 0, 1));
    while(!pq.empty())
    {
        node c = pq.top(); pq.pop();

        if(v[c.index]) continue;
        v[c.index] = true;
        //printf("%d %d\n", c.index, c.f);

        if(c.f == n)
        {
            return c.c;
        }

        for(int i = 0; i < n; i++)
        {
            if(!v[i] && i != c.index)
            {
                int cena = getCena(c.index, i);
                //printf("%d %d %d\n", c.index, i, cena);
                pq.push(node(i, cena + c.c, c.f + 1));
            }
        }
    }
}

int main()
{
    scanf("%d %d", &n, &k);
    for(int i = 0; i < n; i++)
    {
        int r;
        scanf("%d", &r);
        for(int j = 0; j < r; j++)
        {
            int z;
            scanf("%d", &z);
            a[i].push_back(z);
        }
    }

    printf("%d\n", Solve());

    return 0;
}

/*
3 6
3 1 2 3
3 3 4 5
3 4 5 6
*/
