#include<iostream>
#include<vector>

using namespace std;

const int MAXN = 5*(1e5) + 5;

string input;
int n, L = 0, Q;

vector <char> s;
vector <int> skipped;

int prefix[MAXN];

void update(int l, int r)
{
    for(int i = l;i<=r;i++)
    {
        if(s[i]=='+') s[i] = '-';
        else if(s[i]=='-') s[i] = '+';
    }
}

int simulate()
{
    int channel = 1, last = 1, last1;

    //cout << a << '\n';
    for(int i = 0;i<L;i++)
    {
        //cout << "   " << channel << " " << a[i] << '\n';

        if(s[i]=='+')
        {
            last = channel;

            channel++;
            if(channel==n+1) channel = 1;
        }
        else if(s[i]=='-')
        {
            last = channel;

            channel--;
            if(channel==0) channel = n;
        }
        else
        {
            last1 = channel;

            channel = last;
            last = last1;
        }
    }

    return channel;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int ql, qr;
    int index, index1, initial = 0, streek;

    int add;
    int l, r, mid;

    bool fail = false;

    cin >> n >> Q;
    cin >> input;

    index = 0;
    while(index<input.size() && input[index]=='o')
    {
        index++;
        initial++;
    }

    //cout << "OK" << '\n';

    add = 0;
    for(;index<input.size();)
    {
        streek = 0;
        //cout << "--" << index << " " << add << '\n';

        if(index==input.size()-1)
        {
            if(skipped.empty()==false) skipped.push_back(skipped[ skipped.size() - 1 ] + add);
            else
            {
                //cout << "OK " << add << '\n';
                skipped.push_back(add);

                add = 0;
            }

            s.push_back(input[index]);

            index++;
            continue;
        }
        else
        {
            if(input[index+1]!='o')
            {
                //cout << "OK" << '\n';
                //cout << "     " << add << '\n';

                if(skipped.empty()==false) skipped.push_back(skipped[ skipped.size() - 1] + add);
                else
                {
                    skipped.push_back(add);
                }

                s.push_back(input[index]);

                index++;

                add = 0;
                continue;
            }
            else
            {
                index1 = index + 1;
                while(index1<input.size() && input[index1]=='o')
                {
                    index1++;
                    streek++;
                }

                if( (index1-index-1)%2 == 0 )
                {
                    if(skipped.empty()==false)
                    {
                        skipped.push_back(skipped[ skipped.size() - 1 ] + add);
                    }
                    else
                    {
                        skipped.push_back(add);
                    }

                    s.push_back(input[index]);

                    index = index1;
                    //cout << "   " << index << '\n';

                    add = streek;
                    continue;
                }

                index = index1;
                //cout << "   " << index << '\n';
            }
        }

        if(skipped.empty()==false) add += 1 + streek;
        else
        {
            add += 1 + streek;
            //cout << streek << '\n';
        }
    }

    //for(int i = 0;i<s.size();i++) cout << s[i];
    //cout << '\n';

    //for(int i = 0;i<skipped.size();i++)
    //    cout << skipped[i] << " ";
    //cout << '\n';

    L = s.size();
    for(int q = 0;q<Q;q++)
    {
        cin >> ql >> qr;
        if(L==0)
        {
            cout << "1" << '\n';
            continue;
        }


        fail = false;

        ql--;qr--;

        ql -= initial;
        qr -= initial;

        //cout << ql << '\n';
        if(ql>=skipped[ skipped.size() - 1 ] + skipped.size())
        {
            fail = true;
        }

        if(ql-skipped[0]<=0) ql = 0;
        else
        {
            l = 0;
            r = L - 1;

            while(l+1<r)
            {
                mid = (l+r)/2;

                if(skipped[mid]+mid>=ql) r = mid;
                else l = mid + 1;
            }

            if(skipped[l]+l>=ql) ql = l;
            else ql = r;
        }

        //cout << ql << '\n';

        //cout << "----" << '\n';

        if(qr-skipped[0]<0) fail = true;
        else
        {
            l = 0;
            r = L - 1;

            while(l+1<r)
            {
                mid = (l+r)/2;

                if(skipped[mid]+mid<=qr) l = mid;
                else r = mid - 1;
            }

            if(skipped[r]+r<=qr) qr = r;
            else qr = l;
        }

        //cout << qr << '\n';

        //cout << "fail: " << fail << '\n';
        if(fail==false)
        {
            update(ql, qr);
        }

        cout << simulate() << '\n';
    }
}
/*
10 5
++oo+-+o+
1 5
2 6
3 5
6 9
1 8
*/
