#include<iostream>

using namespace std;

const int MAXN = 2005;
const long long mod = 1001027;

int n, k, x;
bool selected[MAXN];

long long dp[MAXN][MAXN];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 0;i<k;i++)
    {
        cin >> x;
        selected[ x - 1] = true;
    }

    n *= 2;
    dp[0][1] = 1;

    for(int i = 1;i<n;i++)
    {
        for(int j = 0;j<=i;j++)
        {
            if(selected[i]==true)
            {
                dp[i][j+1] = (dp[i][j+1] + dp[i-1][j])%mod;
            }
            else
            {
                dp[i][j+1] = (dp[i][j+1] + dp[i-1][j])%mod;
                if(j!=0) dp[i][j-1] = (dp[i][j-1] + dp[i-1][j])%mod;
            }
        }
    }

    cout << dp[n-1][0] << '\n';
}
