#include<iostream>
#include<queue>
#include<vector>
using namespace std;

bool ofis[1002][34];

struct edge{
    int from,to,w;
    const bool operator < (const edge & a) const {
        return this->w>a.w;
    }
};

priority_queue<edge> q;

int vurhove,kat;
int roditel[1002];

int fand(int a){
    if(roditel[a]==a or roditel[a]==-1){
        roditel[a]=a;
        return a;
    }
    return roditel[a]=fand(roditel[a]);
}

void unon(int a,int b){
    if(a<b)swap(a,b);
    roditel[fand(a)]=fand(b);
}

bool svurzani(int a,int b){
    return fand(a)==fand(b);
}

int minpok(){
    int otg=0;
    while(!q.empty()){
        edge curr=q.top();
        if(!svurzani(curr.from,curr.to)){
            unon(curr.from,curr.to);
            otg+=curr.w;
        }
        q.pop();
    }
    return otg;
}

int main(){
    cin.tie(0);
    ios::sync_with_stdio(false);
    cin>>vurhove>>kat;
    for(int i=0;i<vurhove;i++){
        roditel[i]=-1;
        //cout<<"\n#i:"<<i<<"\n";
        int br,a[34];
        cin>>br;
        for(int j=0;j<br;j++){
            cin>>a[j];
            a[j]--;
            ofis[i][a[j]]=true;
        }
        for(int j=0;j<i;j++){
            int ind=-1;
            for(int x=0;x<33;x++){
                if(ofis[j][x] and ofis[i][x]){
                    ind=x;
                    break;
                }
            }
            int reb;
            if(ind==-1){
                reb=kat+1;
            }else{
                reb=ind+1;
            }
            edge rebro;
            rebro.from=i;
            rebro.to=j;
            rebro.w=reb;
            q.push(rebro);
        }
    }
    /*for(int i=0;i<vurhove;i++){
        cout<<"\n#"<<i<<": ";
        for(int j=0;j<susedi[i].size();j++){
            cout<<"("<<susedi[i][j].first<<susedi[i][j].second<<") ";
        }
    }
    cout<<"\n";*/
    cout<<minpok()<<"\n";
    /*for(int i=0;i<vurhove;i++){
        cout<<used[i]<<" ";
    }*/
    return 0;
}
