#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
struct vertex
{
    vector<int> qu;
};
struct rebro
{
    int from,to,price;
    rebro(int a,int b,int c)
    {
        from=a;
        to=b;
        price=c;
    }
    bool operator <(const rebro& b)const
    {
        return price<b.price;
    }
};
int n,k;
vertex offices[1024];
vector<rebro> rebra;
int f(int a,int b)
{
    int i=0,j=0;
    while(offices[a].qu[i]!=offices[b].qu[j])
    {
        if(offices[a].qu[i]<offices[b].qu[j])
        {
            i++;
            if(i>=offices[a].qu.size())
            {
                return k+1;
            }
        }
        if(offices[a].qu[i]>offices[b].qu[j])
        {
            j++;
            if(j>=offices[b].qu.size())
            {
                return k+1;
            }
        }
    }
    return offices[a].qu[i];
}
bool kruskal[1024][1024];
bool ress=0;
bool visited[1025];
void dfs(int tek,int otkude)
{
    //cout<<"vlizame v"<<tek<<"ot"<<otkude<<endl;
    visited[tek]=1;
    for(int i=0;i<n;i++)
    {
        if(kruskal[tek][i]==1)
        {
            //cout<<"ima vruzka"<<tek<<" "<<i<<endl;
            if(visited[i]==1 and i!=otkude)
            {
                //cout<<"k"<<endl;
                ress=1;
                return;
            }
            else if(i!=otkude)
            {
                //cout<<"produljavame ot "<<tek<<" "<<otkude<<" "<<i<<" "<<tek<<endl;
                dfs(i,tek);
                if(ress==1)
                {
                    return;
                }
            }
        }
    }
}
int main()
{
    cin.tie();
    ios::sync_with_stdio();

    cin>>n>>k;
    int q,u;
    for(int i=0; i<n; i++)
    {
        cin>>q;
        for(int j=0; j<q; j++)
        {
            cin>>u;
            offices[i].qu.push_back(u);
        }
    }
    for(int i=0; i<n-1; i++)
    {
        for(int j=i+1; j<n; j++)
        {
            rebra.push_back(rebro(i,j,f(i,j)));
        }
    }
    sort(rebra.begin(),rebra.end());
    /*for(int i=0;i<rebra.size();i++)
    {
        cout<<rebra[i].from<<" "<<rebra[i].to<<" "<<rebra[i].price<<"\n";
    }*/
    int crebra=0,res=0;
    for(int i=0;(i<rebra.size()) and crebra!=n-1;i++)
    {
        //cout<<"try"<<rebra[i].from<<" to "<<rebra[i].to<<endl;
        kruskal[rebra[i].from][rebra[i].to]=1;
        kruskal[rebra[i].to][rebra[i].from]=1;
        ress=0;
        dfs(rebra[i].from,1025);
        if(ress==1)
        {
            //cout<<"fail"<<endl;
            kruskal[rebra[i].from][rebra[i].to]=0;
            kruskal[rebra[i].to][rebra[i].from]=0;
        }
        else
        {
            //cout<<"success"<<endl;
            crebra++;
            res+=rebra[i].price;
        }
        for(int i=0;i<n;i++)
        {
            visited[i]=0;
        }
    }
    cout<<res<<endl;
}
