#include <iostream>
#include <vector>

std::vector<std::vector<int>> syt;
std::vector<bool> emb;

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n, k;
    std::cin >> n >> k;
    syt.resize(k);
    for(int i = 0; i < n; i++) {
        int q;
        std::cin >> q;
        for(int j = 0; j < q; j++) {
            int r;
            std::cin >> r;
            syt[--r].push_back(i);
        }
    }
    emb.resize(n);
    emb[0] = true;
    int cen = 0;
    for(int i = 0; i < k; i++) {
        int cnt = 0;
        if(syt[i].size() == 1) {
            continue;
        }
        for(auto &x: syt[i]) {
            cnt += emb[x];
        }
        if(cnt == syt[i].size() || cnt == 0) {
            continue;
        }
        cen += (syt[i].size() - cnt) * (i+1);
        for(int j = 0; j < syt[i].size(); j++) {
            emb[syt[i][j]] = true;
        }
        i = 0;
    }
    std::cout << cen << std::endl;
    return 0;
}
