#include <iostream>
#include <string>
#include <vector>

std::vector<int> bp;

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n, q;
    std::cin >> n >> q;
    std::string s;
    std::cin >> s;
    bp.resize(s.size() + 1);
    if(s[0] == '+')
        bp[1] = 1;
    for(int i = 1; i < s.size(); i++) {
        bp[i+1] = bp[i] + (s[i] == '+');
    }
    for(int i = 0; i < q; i++) {
        int rb, re;
        std::cin >> rb >> re;
        int prev =  bp[rb-1];
        for(int j = rb; j <= re; j++) {
            if(bp[j]==prev) {
                prev = bp[j];
                bp[j] = bp[j-1] + 1;
            } else {
                prev = bp[j];
                bp[j] = bp[j-1];
            }
        }
        int diff = bp[re] - prev;
        for(int j = re + 1; j < bp.size(); j++) {
            bp[j] += diff;
        }
        int ans = bp[bp.size() - 1] - (s.size() - bp[bp.size()-1]) + 1;
        while(ans > n)
            ans -= n;
        while(ans < 0)
            ans += n;
        std::cout << ans << "\n";
    }
    return 0;
}
