#include <iostream>
#include <string>

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n, q;
    std::cin >> n >> q;
    std::string s;
    std::cin >> s;
    int ans = 1, prev = 1, prevp = -1;
    for(auto &x:s) {
        if(x == '+')
            ans ++;
        else if(x == '-')
            ans --;
        else
            ans = prevp;
        if(ans == 0)
            ans = n;
        else if(ans == n+1)
            ans = 1;
        prevp = prev;
        prev = ans;
    }
    for(int i = 0; i < q; i++) {
        int rb, re;
        std::cin >> rb >> re;
        --rb;
        --re;
        int delta = 0;
        for(int j = rb; j <= re; j++) {
            if(s[j] == '+') {
                s[j] = '-';
                delta -= 2;
            } else if(s[j] == '-') {
                s[j] = '+';
                delta += 2;
            }
        }
        ans += delta;
        while(ans < 0)
            ans += n;
        while(ans > n)
            ans -= n;
        std::cout << ans << "\n";
    }
    return 0;
}
