#include <iostream>
#include <vector>
#include <algorithm>

unsigned n, k;
std::vector<unsigned> pos;
unsigned mem[2000][256][256];

unsigned fun(unsigned posi, unsigned ol, unsigned oo = 0) {
    if(mem[posi][ol][oo])
        return mem[posi][ol][oo];
    if(posi == 2*n-1) {
        return 1;
    }
    if(std::find(std::begin(pos), std::end(pos), posi) != std::end(pos)) {
        return mem[posi][ol][oo] = fun(posi + 1, ol, oo + 1) % 1001027;
    }
    unsigned ans = 0;
    if(ol) {
        ans += fun(posi + 1, ol-1, oo + 1) % 1001027;
    }
    if(oo) {
        ans += fun(posi + 1, ol, oo-1) % 1001027;
    }
    return mem[posi][ol][oo] = ans % 1001027;

}

int main() {
    std::cin >> n >> k;

    pos.resize(k);
    for(unsigned i = 0; i < k; i++) {
        std::cin >> pos[i];
        pos[i] -=1;
    }
    if(pos[k-1] == 2*n-1)
        std::cout << 0 <<std::endl;
    else
        std::cout << fun(0, n - k) % 1001027 << std::endl;
    return 0;
}
