#include <iostream>
#include <queue>

using namespace std;

int n, k;
int R[1001], s[1001][33];

int A[1001][1001], brUsed;
bool used[1001];
int res[1001];

int solve (int curr)
{
    //cout << "curr " << curr << ' ' << res[curr] << '\n';
    if (brUsed == n)
    {
        return res[curr];
    }

    int sol = 99999999999999;
    for (int i = 0; i < n; ++i)
    {
        if (i != curr && !used[i])
        {
            used[i] = true;
            ++brUsed;
            res[i] = res[curr] + A[curr][i];
            sol = min(sol, solve (i));
            used[i] = false;
            --brUsed;
        }
    }

    return sol;
}

int main ()
{
    cin.tie (NULL);
    ios::sync_with_stdio(false);

    cin >> n >> k;

    for (int i = 0; i < n; ++i)
    {
        cin >> R[i];
        for (int j = 0; j < R[i]; ++j)
        {
            cin >> s[i][j];
        }
    }

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            if (i != j)
            {
                int a = 0, b = 0;
                while (a < R[i] && b < R[j])
                {
                    if (s[i][a] == s[j][b])
                    {
                        A[i][j] = s[i][a];
                        break;
                    }

                    if (s[i][a] < s[j][b])
                    {
                        ++a;
                    }
                    else
                    {
                        ++b;
                    }
                }

                if (a == R[i] || b == R[j])
                {
                    A[i][j] = k + 1;
                }
            }

            //cout << A[i][j] << ' ';
        }
        //cout << '\n';
    }

    used[0] = true;
    brUsed = 1;
    cout << solve (0) << '\n';
    return 0;
}

