#include <iostream>
#include <string>

using namespace std;

int n, q;
string seq;

int main ()
{
    cin.tie (NULL);
    ios::sync_with_stdio(false);

    cin >> n >> q;
    cin >> seq;

    for (int j = 0; j < q; ++j)
    {
        int a, b;
        cin >> a >> b;
        --a; --b;

        int res = 1, l1 = 1, l2 = 1;
        for (int i = 0; i < seq.size(); ++i)
        {
            if (a <= i && i <= b)
            {
                if (seq[i] == '+')
                {
                    seq[i] = '-';
                }
                else if (seq[i] == '-')
                {
                    seq[i] = '+';
                }
            }

            if (seq[i] == '+')
            {
                ++res;
            }
            else if (seq[i] == '-')
            {
                --res;
            }
            else
            {
                res = l1;
            }
            l1 = l2;
            l2 = res;

            if (res == n + 1)
            {
                res = 1;
            }
            else if (res == 0)
            {
                res = n;
            }

            //cout << i << ' ' << l1 << ' ' << l2 << "   " << res << '\n';
        }
        //cout << seq << '\n';

        cout << res << '\n';
    }

    return 0;
}
