#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>
using namespace std;

const int N=1005;
const int INF=(1e9);

bool mst[N];
int key[N],edge[N];
vector <int> c[N];
vector < pair <int,int> > g[N];
priority_queue < pair <int,int> > pq;

int main()
{

int n,k,i,j,r,p,q,x,cost,szi,szj,v,to,ans;

scanf("%d%d",&n,&k);

 for(i=1;i<=n;i++)
 {
  scanf("%d",&r);

   for(j=1;j<=r;j++)
   {
    scanf("%d",&x);
    c[i].push_back(x);
   }
 }

 for(i=1;i<=n;i++)
  for(j=i+1;j<=n;j++)
  {
   p=0;
   q=0;

   szi=c[i].size();
   szj=c[j].size();

   cost=k+1;
    while(p<szi && q<szj)
    {
      if(c[i][p]<c[j][q])
      {
       p++;
       continue;
      }

      if(c[j][q]<c[i][p])
      {
       q++;
       continue;
      }

     cost=c[i][p];
     break;
    }

   g[i].push_back(make_pair(j,cost));
   g[j].push_back(make_pair(i,cost));
  }

 for(i=1;i<=n;i++)
  key[i]=INF;

pq.push(make_pair(0,1));
key[1]=0;
 while(!pq.empty())
 {
  v=pq.top().second;
  pq.pop();
  mst[v]=true;

   for(i=0;i<g[v].size();i++)
   {
    to=g[v][i].first;
    cost=g[v][i].second;

     if(!mst[to] && cost<key[to])
     {
      key[to]=cost;
      pq.push(make_pair(-key[to],to));
     }
   }
 }

ans=0;
 for(i=1;i<=n;i++)
  ans+=key[i];

printf("%d\n",ans);

return 0;
}
