#include <iostream>
#include <algorithm>
#include <cstdint>
#include <vector>
using namespace std;

#define MOD 1001027

uint32_t n;
vector<bool> otv;

uint32_t mem[2048][2048];
vector < vector < bool > > is_calculated;

uint32_t rec (uint32_t len, uint32_t to_close)
{
    //cout<<"ADS: "<<n<<' '<<len<<' '<<to_close<<endl;
    if(len==n)
    {
        if(to_close==0)
            return 1;
        return 0;
    }
    //if(n-len<to_close)return 0;
    if(is_calculated[len][to_close])
        return mem[len][to_close];

    //cout<<"DSA: "<<n<<' '<<len<<' '<<to_close<<endl;
    uint32_t res=0;
    if(otv[len]||to_close==0)
        res=rec(len+1, to_close+1)%MOD;
    else
    {
        res =rec(len+1, to_close+1)%MOD;
        res+=rec(len+1, to_close-1)%MOD;
        res=res%MOD;
    }
    mem[len][to_close]=res;
    is_calculated[len][to_close]=true;
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t k;
    cin>>n>>k;
    n<<=1;
    is_calculated.resize(n+1);
    for(uint32_t i=0; i<n+1; i++)
        is_calculated[i].resize(n+1);
    otv.resize(n);
    for(uint32_t i=0; i<k; i++)
    {
        uint32_t x;
        cin>>x;
        otv[x-1]=true;
    }
    cout<<rec(0, 0)<<endl;

    return 0;
}
