#include <iostream>
using namespace std;

const int MAXN = 2 * 1024;
const int MOD = 1001027;

int n, k;
int dp[MAXN][MAXN], open[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    for (int i = 1; i <= k; ++ i)
    {
        int x;
        cin >> x;
        open[x] = 1;
    }
}

void Solve()
{
    dp[0][0] = 1;
    for (int i = 1; i < MAXN - 3; ++ i)
    {
        for (int j = 0; j < MAXN - 3; ++ j)
        {
            if (j != 0) dp[i][j] = dp[i - 1][j - 1];            // adding '('
            if (open[i] == 0) dp[i][j] += dp[i - 1][j + 1];     // adding ')'
            dp[i][j] %= MOD;
        }
    }
}

int main()
{
    Init();
    Solve();

    cout << dp[2 * n][0] << endl;
    return 0;
}
