#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int maxN=1010,maxK=35;
int n,k,m,cnt;
long long ans;
struct edge{
    int b,e,tg;
    edge(){}
    edge(int u,int v,int t){
        b=u;
        e=v;
        tg=t;
    }
}edges[maxN*maxN];
bool cmp(edge a,edge b)
{
    return a.tg < b.tg;
}
vector<int> a[maxN];
void makeEdge(int i,int j)
{
    int u=0,v=0;
    while(u!=a[i].size() || v!=a[j].size())
    {
        if(a[i][u] < a[j][v])u++;
        else if(a[i][u] > a[j][v])v++;
        else break;
    }
    edges[m++]=edge(i,j,a[i][u]);
}
int par[maxN],h[maxN];
int findPar(int a)
{
    if(par[a]==a)return a;
    int y=findPar(par[a]);
    par[a]=y;
    return y;
}
void unite(edge a)
{
    int para=findPar(a.b);
    int parb=findPar(a.e);
    if(para==parb)return;
    cnt++;
    if(h[para] > h[parb])par[parb]=para;
    else if(h[parb] > h[para])par[para]=parb;
    else {
        par[parb]=para;
        h[para]++;
    }
    ans+=a.tg;
}
int main()
{
    int i,j,r,p;
    cin>>n>>k;
    for(i=0;i<n;i++)
    {
        cin>>r;
        for(j=0;j<r;j++)
        {
            cin>>p;
            a[i].push_back(p);
        }
        a[i].push_back(k+1);
    }
    for(i=0;i<n;i++)
    {
        for(j=i+1;j<n;j++)
        {
            makeEdge(i,j);
        }
    }
    sort(edges,edges+m,cmp);
    for(i=0;i<n;i++)
    {
        par[i]=i;
        h[i]=1;
    }
    for(i=0;i<m;i++)
    {
        unite(edges[i]);
        if(cnt==n-1)break;
    }
    cout<<ans<<endl;
}
/**
3 6
3 1 2 3
3 3 4 5
3 4 5 6
*/
