#include <iostream>
#include <algorithm>
#include <memory.h>
using namespace std;
struct edge
{
    int u, v, tg;
    edge(){};
    edge (int a, int b, int c)
    {
        u=a, v=b, tg=c;
    }
}edges[1001];
int n, k, r[1001], sytr[1001][35], /*tmp[1001][1001],*/ parent[1001], depth[1001], tmp;
bool bin_search(int i, int j, int p)
{
    int le=0, ri=n;
    while(1)
    {
        if (ri-le<=1) break;
        int mid=(le+ri)/2;
        //cout <<le<<" "<<ri<<" "<<mid<<endl;
        if (sytr[i][j]==sytr[p][mid]) return 1;
        else if (sytr[i][j]>sytr[p][mid]) le=mid;
        else ri=mid;
    }
    //cout <<le<<" "<<ri<<endl;
    if (sytr[i][j]==sytr[p][le] || sytr[i][j]==sytr[p][ri]) return 1;
    return 0;
}
int find_root (int r)
{
    int i;
    for (i=r; i!=parent[i]; i=parent[i])
    {
        parent[i]=parent[parent[i]];
    }
    return i;
}
int main ()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cin >>n>>k;
    for (int i=0; i<n; i++)
    {
        cin >>r[i];
        for (int j=0; j<r[i]; j++)
        {
            cin >>sytr[i][j];
            /*if (i==0) continue;
            for (int p=i-1; p>=0; p--)
            {
                if (tmp[i][p]) continue;
                if (bin_search(i,j,p))
                {
                    tmp[i][p]=sytr[i][j];
                }
            }
            edges[cnt++]=*/
        }
    }
    int cnt=0, mst=0;
    /*for (int i=0; i<n; i++)
    {
        for (int j=0; j<n; j++)
        {
            if (tmp[i][j]==0 && i>j) tmp[i][j]=k+1;
            if (tmp[i][j])
            {
                cnt++;
                cout <<j<<" "<<i<<" "<<tmp[i][j]<<endl;
            }
        }
    }*/
    for (int i=1; i<n; i++)
    {
        for (int p=i-1; p>=0; p--)
        {
            tmp=k+1;
            for (int j=0; j<r[i]; j++)
            {
                if (bin_search(i,j,p))
                {
                    tmp=sytr[i][j];
                    break;
                }
            }
            edges[cnt++]=edge(p,i,tmp);
        }
    }
    for (int i=0; i<n; i++)
    {
        parent[i]=i;
        depth[i]=1;
    }
    int br=0;
    for (int i=0; i<cnt; i++)
    {
        //cout <<edges[i].u<<" "<<edges[i].v<<" "<<edges[i].tg<<endl;
        int ru=find_root(edges[i].u);
        int rv=find_root(edges[i].v);
        if (ru==rv) continue;
        if (depth[ru]<depth[rv]) parent[ru]=rv;
        else if (depth[rv]<depth[ru]) parent[rv]=ru;
        else parent[rv]=ru, depth[ru]++;
        mst+=edges[i].tg;
        if (br==n-1) break;
        br++;
    }
    cout <<mst<<endl;

}
