#include <cstdio>
#include <algorithm>
using namespace std;
struct edge
{
    int u, v, tg;
    edge(){};
    edge (int a, int b, int c)
    {
        u=a, v=b, tg=c;
    }
}edges[1001];
int n, k, r[1001], sytr[1001][35], parent[1001], depth[1001], tmp;
bool cmp (edge a, edge b)
{
    return a.tg<b.tg;
}
bool bin_search(int i, int j, int p)
{
    int le=0, ri=r[p];
    while(1)
    {
        if (ri-le<=1) break;
        int mid=(le+ri)/2;
        if (sytr[i][j]==sytr[p][mid]) return 1;
        else if (sytr[i][j]>sytr[p][mid]) le=mid;
        else ri=mid;
    }
    if (sytr[i][j]==sytr[p][le] || sytr[i][j]==sytr[p][ri]) return 1;
    return 0;
}
int find_root (int r)
{
    int i;
    for (i=r; i!=parent[i]; i=parent[i])
    {
        parent[i]=parent[parent[i]];
    }
    return i;
}
int main ()
{
    scanf ("%d%d",&n,&k);//cin >>n>>k;
    for (int i=0; i<n; i++)
    {
        scanf("%d",&r[i]);  //cin >>r[i];
        for (int j=0; j<r[i]; j++)
        {
            scanf("%d",&sytr[i][j]);    //cin >>sytr[i][j];
        }
    }
    int cnt=0, mst=0;
    for (int i=1; i<n; i++)
    {
        for (int p=i-1; p>=0; p--)
        {
            tmp=k+1;
            for (int j=0; j<r[i]; j++)
            {
                if (bin_search(i,j,p))
                {
                    tmp=sytr[i][j];
                    break;
                }
            }
            edges[cnt++]=edge(p,i,tmp);
        }
    }
    sort(edges,edges+cnt,cmp);
    for (int i=0; i<n; i++)
    {
        parent[i]=i;
        depth[i]=1;
    }
    int br=0;
    for (int i=0; i<cnt; i++)
    {
        int ru=find_root(edges[i].u);
        int rv=find_root(edges[i].v);
        if (ru==rv) continue;
        if (depth[ru]<depth[rv]) parent[ru]=rv;
        else if (depth[rv]<depth[ru]) parent[rv]=ru;
        else parent[rv]=ru, depth[ru]++;
        mst+=edges[i].tg;
        if (br==n-1) break;
        br++;
    }
    if (br!=n-1) printf("0\n"); ///cout <<0<<endl;
    else printf("%d\n",mst);    ///cout <<mst<<endl;

}
/**
4 16
2 1 8
5 1 2 3 4 5
3 8 9 11
4 4 6 7 11
*/
